/* Program SPLIT.C */
/* By Harald Stauss */
/* Last change 30.06.95 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/* #include <iostream.h> */

main(int argc, char *argv[])
{
  int            wert, fc;
  unsigned long  n, nmax;
  FILE           *indat, *outdat;
  char           fin[250], fout[250], hs[250];
  
  printf("SPLIT Ver.1.0 by H. Stauss, 1995 \n");
  
  if (argc != 3)
    {
      printf("Number of parameters wrong! \n");
      printf("Changes all TAB to SPACE and \n");
      printf("splits the file into segments of n lines each\n");
      printf("SPLIT f_in n \n");
      printf("f_in  : name of input file. \n");
      printf("n     : number of lines per segment");
      goto ende;
    }
  
  nmax=atol(argv[2]);
  strcpy(fin,argv[1]);
  /* Eingabedatei oeffnen */
  indat = fopen(fin,"r+b");
  if (indat==NULL)
    {
      printf("Can't open file %s \n",argv[1]);
      goto ende;
    }
  
  printf("Input file          : %s \n", fin);
  printf("max. number of lines: %d \n", nmax);
  
  n=0; fc=1;
  
  /* Ausgabedatei oeffnen */
  strcpy(fout,fin); sprintf(hs,".%d",fc); strcat(fout,hs);
  outdat = fopen(fout,"w+b");
  if (outdat==NULL)
    {
      printf("Can't open file %s \n",fout);
      goto ende;
    }
  
  /*  M A I N L O O P  */
  while (feof(indat)==0) {
    wert=fgetc(indat);
    /*   if (wert==9) wert=32; */  /* Tab to Space */
    if (wert==13) wert=10;      /* CR/LF        */
    if (wert!='\377') fputc(wert,outdat);
    if (wert==10) {
      n++;
      if (n>=nmax) {
	fclose(outdat);
	fc++; n=0;
	/* Ausgabedatei oeffnen */
	strcpy(fout,fin); sprintf(hs,".%d",fc); strcat(fout,hs);
	outdat = fopen(fout,"w+b");
	if (outdat==NULL)
	  {
	    printf("Can't open file %s \n",fout);
	    goto ende;
	  }
      }
    }
  } /* endwhile */
  

  fclose(indat); fclose(outdat);

 ende: 

  return(0);

} /* Ende von main */
